'use strict'

module.exports = mouseWheelListen

function mouseWheelListen(element, callback, noScroll) {
  if(typeof element === 'function') {
    noScroll = !!callback
    callback = element
    element = window
  }
  var lineHeight = getLineHeight(element)

  var listener = function(ev) {
    if(noScroll) {
      ev.preventDefault()
    }
    var dx = ev.deltaX || 0
    var dy = ev.deltaY || 0
    var dz = ev.deltaZ || 0
    var mode = ev.deltaMode
    var scale = 1
    switch(mode) {
      case 1:
        scale = lineHeight
      break
      case 2:
        scale = window.innerHeight
      break
    }
    dx *= scale
    dy *= scale
    dz *= scale
    if(dx || dy || dz) {
      return callback(dx, dy, dz, ev)
    }
  }
  element.addEventListener('wheel', listener)
  return listener
}

function getLineHeight(element){
   var temp = document.createElement(element.nodeName);
   temp.setAttribute("style", "margin:0px;padding:0px;font-size:" + element.style.fontSize);
   temp.innerHTML = "t";
   temp = element.parentNode.appendChild(temp);
   var h = temp.clientHeight;
   temp.parentNode.removeChild(temp);
   return h;
 }
